searchNodes=[{"doc":"Loads dynamic configuration at runtime.Why Vapor?Dynamically configuring elixir apps can be hard. There are major differences between configuring applications with mix and configuring applications in a release. Vapor wants to make all of that easy by providing an alternative to mix config for runtime configs. Specifically Vapor can:Find and load configuration from files (JSON, YAML, TOML).Read configuration from environment variables..env file support for easy local development.Exampledefmodule VaporExample.Application do use Application alias Vapor.Provider.{File, Env} def start(_type, _args) do providers = [ %Env{bindings: [db_url: &quot;DB_URL&quot;, db_name: &quot;DB_NAME&quot;, port: &quot;PORT&quot;]}, %File{path: &quot;config.toml&quot;, bindings: [kafka_brokers: &quot;kafka.brokers&quot;]}, ] # If values could not be found we raise an exception and halt the boot # process config = Vapor.load!(providers) children = [ {VaporExampleWeb.Endpoint, port: config.port} {VaporExample.Repo, [db_url: config.db_url, db_name: config.db_name]}, {VaporExample.Kafka, brokers: config.kafka_brokers}, ] opts = [strategy: :one_for_one, name: VaporExample.Supervisor] Supervisor.start_link(children, opts) end endPrecedenceVapor merges the configuration based on the order that the providers are specified.providers = [ %Dotenv{}, %File{path: &quot;$HOME/.vapor/config.json&quot;, bindings: []}, %Env{bindings: []}, ]Env will have the highest precedence, followed by File, and finally Dotenv.Reading config filesConfig files can be read from a number of different file types including JSON, TOML, and YAML. Vapor determines which file format to use based on the file extension.Options on bindingsBindings for %Env{} and %File{} providers support a number of options::map - Allows you to pass a &quot;translation&quot; function with the binding.:default - If the value is not found then the default value will be returned instead. Defaults always skip the translations.:required - Marks the binding a required or not required (defaults to true). If required values are missing, and there is no default present, then the provider will return an exception. If the binding is marked required: false, then the provider returns the key with a nil value.providers = [ %Env{ bindings: [ {:db_name, &quot;DB_NAME&quot;}, {:db_port, &quot;DB_PORT&quot;, default: 4369, map: &amp;String.to_integer/1}, ] } ]Adding configuration plans to modulesVapor provides a Vapor.Plan behaviour. This allows modules to describe a provider or set of providers.defmodule VaporExample.Kafka do @behaviour Vapor.Plan @impl Vapor.Plan def config_plan do %Vapor.Provider.Env{ bindings: [ {:brokers, &quot;KAFKA_BROKERS&quot;}, {:group_id, &quot;KAFKA_CONSUMER_GROUP_ID&quot;}, ] } end end config = Vapor.load!(VaporExample.Kafka)Planner DSLWhile using the structs directly is a perfectly reasonable option, it can often be verbose. Vapor provides a DSL for specifying configuration plans using less lines of code.defmodule VaporExample.Config do use Vapor.Planner dotenv() config :db, env([ {:url, &quot;DB_URL&quot;}, {:name, &quot;DB_NAME&quot;}, {:pool_size, &quot;DB_POOL_SIZE&quot;, default: 10, map: &amp;String.to_integer/1}, ]) config :web, env([ {:port, &quot;PORT&quot;, map: &amp;String.to_integer/1} ]) config :kafka, VaporExample.Kafka end defmodule VaporExample.Application do use Application def start(_type, _args) do config = Vapor.load!(VaporExample.Config) children = [ {VaporExampleWeb.Endpoint, config.web} {VaporExample.Repo, config.db}, {VaporExample.Kafka, config.kafka}, ] opts = [strategy: :one_for_one, name: VaporExample.Supervisor] Supervisor.start_link(children, opts) end endCustom ProvidersThere are several built in providersEnvironment.env filesJSONYAMLTOMLIf you need to create a new provider you can do so with the included Vapor.Provider protocol.defmodule MyApp.DatabaseProvider do defstruct [id: nil] defimpl Vapor.Provider do def load(db_provider) do end end end","ref":"Vapor.html","title":"Vapor","type":"module"},{"doc":"Loads a configuration plan.","ref":"Vapor.html#load/2","title":"Vapor.load/2","type":"function"},{"doc":"Loads a configuration plan or raises","ref":"Vapor.html#load!/2","title":"Vapor.load!/2","type":"function"},{"doc":"This module provides a behaviour that allows other modules to define their own configuration plans. This allows modules to define their configuration on the module which can later be loaded using Vapor.load/1.","ref":"Vapor.Plan.html","title":"Vapor.Plan","type":"behaviour"},{"doc":"","ref":"Vapor.Plan.html#c:config_plan/0","title":"Vapor.Plan.config_plan/0","type":"callback"},{"doc":"This module provides a DSL for building configuration plans.defmodule MyApp.Config do use Vapor.Planner dotenv() config :env, env([ foo: &quot;FOO&quot;, bar: &quot;BAR&quot;, ]) config :file, file(&quot;test/support/settings.json&quot;, [ foo: &quot;foo&quot;, baz: &quot;baz&quot;, boz: [&quot;biz&quot;, &quot;boz&quot;], ]) config :kafka, MyApp.KafkaWorker end","ref":"Vapor.Planner.html","title":"Vapor.Planner","type":"module"},{"doc":"","ref":"Vapor.Planner.html#config/2","title":"Vapor.Planner.config/2","type":"macro"},{"doc":"","ref":"Vapor.Planner.html#dotenv/0","title":"Vapor.Planner.dotenv/0","type":"macro"},{"doc":"","ref":"Vapor.Planner.html#env/1","title":"Vapor.Planner.env/1","type":"function"},{"doc":"","ref":"Vapor.Planner.html#file/2","title":"Vapor.Planner.file/2","type":"function"},{"doc":"","ref":"Vapor.Provider.html","title":"Vapor.Provider","type":"protocol"},{"doc":"The protocol required for loading a configuration. Providers need to implement this protocol and must return either an {:ok, %{}} or {:error, term()}.","ref":"Vapor.Provider.html#load/1","title":"Vapor.Provider.load/1","type":"function"},{"doc":"","ref":"Vapor.Provider.html#t:t/0","title":"Vapor.Provider.t/0","type":"type"},{"doc":"The dotenv config provider will look for a .env file and load all of the values for that file. The values can be written like so:DATABASE_URL=https://localhost:9432 PORT=4000 REDIS_HOST=1234Multiline variables can be written using bash-style heredocs like so:API_PRIVATE_KEY=&lt;&lt; EOF -----BEGIN RSA PRIVATE KEY----- MIIEogIBAAKCAQEArq74P2ButEMolub0tHfxdWSLcaGi7Da7IJX7jOZFdcSjvXjt ... 4A5j0wlIuJqz+OZmV+WSOlJdFXQugTaMd6hMLG8SE6AvEM+L91E= -----END RSA PRIVATE KEY----- EOF PORT=4000 REDIS_HOST=1234If the file can't be found then this provider will still return an ok but will (obviously) not load any configuration values. The primary use case for this provider is local development where it might be inconvenient to add all of the necessary environment variables on your local machine and it makes tradeoffs for that use case.Existing environment variablesBy default the dotenv provider won't overwrite any existing environment variables. You can change this by setting the overwrite key to true:%Dotenv{overwrite: true}File hierarchyIf no file is specified then the dotenv provider will load these files in this order. Each proceeding file is loaded over the previous. In these examples ENV will be the current mix environment: dev, test, or prod..env.env.ENV.env.local.env.ENV.localYou should commit .env and .env.ENV files to your project and ignore any .local files. This allows users to provide a custom setup if they need to do that.","ref":"Vapor.Provider.Dotenv.html","title":"Vapor.Provider.Dotenv","type":"module"},{"doc":"The Env config module provides support for pulling configuration values from the environment. Bindings must be specified at a keyword list.Example%Env{bindings: [foo: &quot;FOO&quot;, bar: &quot;VAR_BAR&quot;]}","ref":"Vapor.Provider.Env.html","title":"Vapor.Provider.Env","type":"module"},{"doc":"Module for loading supported file format configs Supported file formats: .json, .toml, .yaml. Bindings to specific keys must be provided as a keyword list. The values for each key must be either a string or a path based on the Access protocol.Example%File{path: &quot;config.toml&quot;, bindings: [foo: &quot;foo&quot;, nested: [&quot;some&quot;, &quot;nested&quot;, &quot;value&quot;]]}","ref":"Vapor.Provider.File.html","title":"Vapor.Provider.File","type":"module"},{"doc":"","ref":"Vapor.Provider.File.html#s/0","title":"Vapor.Provider.File.s/0","type":"function"},{"doc":"Allows users to group together bits of configuration. This allows users to avoid duplication and avoids conflicts in common names such as &quot;port&quot; and &quot;host&quot;.Exampleproviders = [ %Group{ name: :primary_db, providers: [ %Env{bindings: [port: &quot;PRIMARY_DB_PORT&quot;, host: &quot;PRIMARY_DB_HOST&quot;]}, ] }, %Group{ name: :redis, providers: [ %Env{bindings: [port: &quot;REDIS_PORT&quot;, host: &quot;REDIS_HOST&quot;]}, ] }, ]","ref":"Vapor.Provider.Group.html","title":"Vapor.Provider.Group","type":"module"},{"doc":"","ref":"Vapor.FileFormatNotFoundError.html","title":"Vapor.FileFormatNotFoundError","type":"exception"},{"doc":"","ref":"Vapor.FileNotFoundError.html","title":"Vapor.FileNotFoundError","type":"exception"},{"doc":"","ref":"Vapor.LoadError.html","title":"Vapor.LoadError","type":"exception"}]